/*	mystrlib.cpp    */

#include	"mystrlib.h"
#include	<cstdlib>
#include	<cstring>
#include	<algorithm>

using	namespace	std;

// "type-safe" versions of tolower and toupper which are used below

char	makelowercase( char c )	{ return static_cast<char>( tolower( static_cast<int>(c) ) ); }
char	makeuppercase( char c )	{ return static_cast<char>( toupper( static_cast<int>(c) ) ); }


string strtolower( const string& s )
{
	string result;
	
	result.resize( s.size() );
	transform( s.begin(), s.end(), result.begin(), makelowercase );
	
	return result;
}

string strtoupper( const string& s )
{
	string result;
	
	result.resize( s.size() );
	transform( s.begin(), s.end(), result.begin(), makeuppercase );
	
	return result;
}


bool	MatchWithWildcards( const std::string& s, const std::string& pattern )
{
	if	( s.empty() or pattern.empty() )	return false;
	
	size_t lens = s.size();
	size_t lenp = pattern.size();
	size_t poss = 0, posp = 0;
	
	while	( poss < lens and posp < lenp )	{
		if	( pattern.at(posp) == '?' )	{
			++poss; ++posp;
		}
		else	if	( pattern.at(posp) == '*' )	{
			++posp;
			if	( posp == lenp )	return true;
			while	( poss != lens and not MatchWithWildcards( s.substr(poss), pattern.substr(posp) ) )
				++poss;
		}
		else	if	( s.at(poss) != pattern.at(posp) )
			return false;
		else	{
			++poss; ++posp;
		}
	}
	
	if	( poss == lens and posp == lenp )
		return true;
	else	if	( poss == lens and posp == (lenp - 1) and pattern.at(posp) == '*' )
		return true;
	else	return false;
}


bool	AnyNonWhitespace( const std::string& s )
{
	std::string::size_type	len = s.length();
	
	for	( std::string::size_type pos = 0; pos < len; ++pos )
		if	( ! isspace( s.at(pos) ) )	return true;
	
	return false;
}

