/*	mystrlib.cpp

	Anthony Kozar
	January 8, 2002
	
	Some useful string functions.
	
	Changes:
	04/21/02	added MatchWithWildcards()
	11/23/02	added AnyNonWhitespace()
 */

#ifndef	ANTHONY_STR_LIB_H
#define	ANTHONY_STR_LIB_H

#include	<string>

char	makelowercase( char c );
char	makeuppercase( char c );

std::string strtolower( const std::string& s );
std::string strtoupper( const std::string& s );

/*	Matches two strings using a ? wildcard to match any single character
	and a * wildcard to match zero or more characters.  All other
	characters match themselves.  Wildcards may only occur in pattern.
 */
bool	MatchWithWildcards( const std::string& s, const std::string& pattern );

//	AnyNonWhitespace() : checks a string to see if it contains any non-whitespace characters
bool	AnyNonWhitespace( const std::string& s );

#endif
