/*	SimpleMixer.h

	A mixer module which combines any number of inputs equally and 
	prevents clipping by dividing by the number of inputs.
	
	Anthony Kozar
	September 19, 2002
 */
 
/*
	The AM1 Synthesizer for Macintosh, version 0.50 beta
	Copyright (C) 2003 The University of Toledo.
	All rights reserved.

	Redistribution and use in source and binary forms, with or without modification,
	are permitted provided that the following conditions are met:

	1.    Redistributions of source code must retain the above copyright notice,
	      this list of conditions and the following disclaimer. 
	2.    Redistributions in binary form must reproduce the above copyright notice,
	      this list of conditions and the following disclaimer in the documentation
	      and/or other materials provided with the distribution. 
	3.    The names of the authors and of the University of Toledo may not be used
	      to endorse or promote products derived from this software without specific
	      prior written permission. 

	THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND THE UNIVERSITY OF TOLEDO "AS IS" AND
	ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
	DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR THE UNIVERSITY OF TOLEDO BE LIABLE
	FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
	DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
	SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
	CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef	ANTHONY_SIMPLE_MIXER_H
#define	ANTHONY_SIMPLE_MIXER_H

#include	<cstdlib>
#include	"AbstractMixer.h"

namespace AAF = AnthonyAudioFramework;

namespace	AnthonyAudioClasses	{

class	SimpleMixer : public AbstractMixer
{
	public:
		SimpleMixer() : AbstractMixer() {}
		SimpleMixer( AAF::AudioAbstract* out, std::size_t port ) : AbstractMixer( out, port ) {}
		SimpleMixer( AAF::AudioAbstract* out, std::size_t port, std::size_t numInputs ) : AbstractMixer( out, port, numInputs ) {}
		//virtual ~SimpleMixer();
		
	protected:
		virtual void Mix( std::size_t input_pos, AAF::AudioSample* result );
};

}	// namespace closure

#endif
