/*	SineWave.cpp    */

/*
	The AM1 Synthesizer for Macintosh, version 0.50 beta
	Copyright (C) 2003 The University of Toledo.
	All rights reserved.

	Redistribution and use in source and binary forms, with or without modification,
	are permitted provided that the following conditions are met:

	1.    Redistributions of source code must retain the above copyright notice,
	      this list of conditions and the following disclaimer. 
	2.    Redistributions in binary form must reproduce the above copyright notice,
	      this list of conditions and the following disclaimer in the documentation
	      and/or other materials provided with the distribution. 
	3.    The names of the authors and of the University of Toledo may not be used
	      to endorse or promote products derived from this software without specific
	      prior written permission. 

	THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND THE UNIVERSITY OF TOLEDO "AS IS" AND
	ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
	DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR THE UNIVERSITY OF TOLEDO BE LIABLE
	FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
	DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
	SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
	CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include	<cmath>
#include	"SineWave.h"

using	namespace	std;
using	namespace	AnthonyAudioFramework;

namespace	AnthonyAudioClasses	{

// constructors

SineWave::SineWave() //: AudioAbstract()
	: AbstractOscillator()
{
//	_frequency = _phase = _curPhase = 0;
}

SineWave::SineWave( AudioAbstract* out, size_t port ) //: AudioAbstract( out, port )
	: AbstractOscillator( out, port )
{
//	_frequency = _phase = _curPhase = 0;
}

SineWave::SineWave( AudioAbstract* out, size_t port, double frequency ) //: AudioAbstract( out, port )
	: AbstractOscillator( out, port, frequency )
{
/*	_frequency = frequency;
	_phase = _curPhase = 0;
*/}

SineWave::SineWave( AudioAbstract* out, size_t port, double frequency, double amplitude ) //: AudioAbstract( out, port )
	: AbstractOscillator( out, port, frequency, amplitude )
{
/*	_frequency = frequency;
	_phase = phase;
	_curPhase = 0;
*/
}

SineWave::SineWave( AudioAbstract* out, size_t port, double frequency, double amplitude, double phase ) //: AudioAbstract( out, port )
	: AbstractOscillator( out, port, frequency, amplitude )
{
	AbstractOscillator::Phase(phase);
/*	_frequency = frequency;
	_phase = phase;
	_curPhase = 0;
*/
}


// sine wave generator 

double SineWave::GenerateSample( double freq, double amp, double pw )
{
	return (double)AUDIOSAMPLE_MAX * sin(2*PI*_curPhase);
}

/*size_t SineWave::GetSamples( AudioSample* buffer, size_t samplesWanted )
{
	int	chan = Channels();
	
	// calculate the phase increment per sample
	double phaseIncr = _frequency / (double)SamplingRate();
	
	// return only an exact multiple of the # of channels of samples
	size_t	samplesToMake = samplesWanted - samplesWanted % chan;
	size_t	samplesMade = 0;
	AudioSample	value;
	
	for	( ; samplesMade < samplesToMake; samplesMade+= chan )	{
		value = (AudioSample)( AUDIOSAMPLE_MAX * sin(2*PI*_curPhase) );
		for	( int ch = 0; ch < chan; ch++ )						// copy sample into buffer for each channel
			buffer[samplesMade+ch] = value;
			
		_curPhase = fmod( _curPhase + phaseIncr, 1.0 );					// update the sine wave's phase
	}
	
	return samplesMade;
}


void	SineWave::Reset()
{
	AudioAbstract::Reset();
	_curPhase = _phase;
	return;
}

		
void	SineWave::InitializeForPlay()
{
	AudioAbstract::InitializeForPlay();
	_curPhase = _phase;
	return;
}
*/
		
}	// namespace closure
