/*	CSMult.h

	Control source to multiply two control sources together.
	
	Anthony Kozar
	May 12, 2003
	
 */

/*
	The AM1 Synthesizer for Macintosh, version 0.50 beta
	Copyright (C) 2003 The University of Toledo.
	All rights reserved.

	Redistribution and use in source and binary forms, with or without modification,
	are permitted provided that the following conditions are met:

	1.    Redistributions of source code must retain the above copyright notice,
	      this list of conditions and the following disclaimer. 
	2.    Redistributions in binary form must reproduce the above copyright notice,
	      this list of conditions and the following disclaimer in the documentation
	      and/or other materials provided with the distribution. 
	3.    The names of the authors and of the University of Toledo may not be used
	      to endorse or promote products derived from this software without specific
	      prior written permission. 

	THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND THE UNIVERSITY OF TOLEDO "AS IS" AND
	ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
	DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR THE UNIVERSITY OF TOLEDO BE LIABLE
	FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
	DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
	SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
	CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef	ANTHONY_CS_MULT
#define	ANTHONY_CS_MULT

#include	"AbstractControlSource.h"

namespace AAF = AnthonyAudioFramework;

class	CSMult : public AAF::AbstractControlSource
{	
	public:		
		CSMult( unsigned long controlRate );
		CSMult( unsigned long controlRate, AAF::AbstractControlSource* sourceA, AAF::AbstractControlSource* sourceB );
		
		virtual void	Update();		
		virtual void	Reset();		
		
		void		SourceAMod( AAF::AbstractControlSource* cs, double amount )	{ _sourceA = cs; _sourceAAmt = amount; }
		void		SourceBMod( AAF::AbstractControlSource* cs, double amount )	{ _sourceB = cs; _sourceBAmt = amount; }
	
	protected:
		AAF::AbstractControlSource*	_sourceA;
		double				_sourceAAmt;
		AAF::AbstractControlSource*	_sourceB;
		double				_sourceBAmt;
		
};

#endif
